#ifndef LCD_MATRIX_H
#define LCD_MATRIX_H

#define GPIO1               36
#define GPIO2               37
#define GPIO3               38
#define GPIO4               39
#define GPIO5               170
#define GPIO6               169
#define GPIO7               2
#define GPIO8               6 

#define CLK_PIN             GPIO6
#define MOSI_PIN            GPIO7
#define LD_PIN              GPIO5

#define BUTTON_INT_NAME     "button_interrupt"
#define BUTTON_PIN          GPIO2
#define BUTTON_DEBOUNCE     10000

#define HIGH                1
#define LOW                 0

#define SPI_WORD_LEN        16
#define SPI_CLK_PERIOD_HALF 1

#define OP_NOOP             0
#define OP_DIGIT0           1
#define OP_DIGIT1           2
#define OP_DIGIT2           3
#define OP_DIGIT3           4
#define OP_DIGIT4           5
#define OP_DIGIT5           6
#define OP_DIGIT6           7
#define OP_DIGIT7           8
#define OP_DECODEMODE       9
#define OP_INTENSITY        10
#define OP_SCANLIMIT        11
#define OP_SHUTDOWN         12
#define OP_DISPLAYTEST      15

typedef enum{
  ROW_0 = 1,
  ROW_1,
  ROW_2,
  ROW_3,
  ROW_4,
  ROW_5,
  ROW_6,
  ROW_7
} rowNum_typedef;

#define NUM_ROWS_DISPLAY    8

#define NORMAL_OPERARION    1
#define SHUTDOWN_MODE       0

#define DISPLAY_TEST_TIME   2000 // ms
#define TIME_BETWEEN_CHAR   500  // ms
// #define TIME_BETWEEN_EXEC   500  // ms

#define TIME_BETWEEN_EXEC   500  // ms

#define STRING_TEST         "Teste de tempo"
#define STRING_IRQ_TEST     "IRQ_TESTE_OK!"

#define INITIAL_CHAR_VALUE  '0'
#define FINAL_CHAR_VALUE    '9'

/*Numeric Font Matrix (Arranged as 7x font data + 1x kerning data)*/
static unsigned char font5x7 [][8] = {
  0b00000000,	//Space (Char 0x20)
  0b00000000,
  0b00000000,
  0b00000000,
  0b00000000,
  0b00000000,
  0b00000000,
  0b00000000,

  0b10000000,	//!
  0b10000000,
  0b10000000,
  0b10000000,
  0b00000000,
  0b00000000,
  0b10000000,
  0b00000000,

  0b10100000,	//"
  0b10100000,
  0b10100000,
  0b00000000,
  0b00000000,
  0b00000000,
  0b00000000,
  0b00000000,

  0b01010000,	//#
  0b01010000,
  0b11111000,
  0b01010000,
  0b11111000,
  0b01010000,
  0b01010000,
  0b00000000,

  0b00100000,	//$
  0b01111000,
  0b10100000,
  0b01110000,
  0b00101000,
  0b11110000,
  0b00100000,
  0b00000000,

  0b11000000,	//%
  0b11001000,
  0b00010000,
  0b00100000,
  0b01000000,
  0b10011000,
  0b00011000,
  0b00000000,

  0b01100000,	//&
  0b10010000,
  0b10100000,
  0b01000000,
  0b10101000,
  0b10010000,
  0b01101000,
  0b00000000,

  0b11000000,	//'
  0b01000000,
  0b10000000,
  0b00000000,
  0b00000000,
  0b00000000,
  0b00000000,
  0b00000000,

  0b00100000,	//(
  0b01000000,
  0b10000000,
  0b10000000,
  0b10000000,
  0b01000000,
  0b00100000,
  0b00000000,

  0b10000000,	//)
  0b01000000,
  0b00100000,
  0b00100000,
  0b00100000,
  0b01000000,
  0b10000000,
  0b00000000,

  0b00000000,	//*
  0b00100000,
  0b10101000,
  0b01110000,
  0b10101000,
  0b00100000,
  0b00000000,
  0b00000000,

  0b00000000,	//+
  0b00100000,
  0b00100000,
  0b11111000,
  0b00100000,
  0b00100000,
  0b00000000,
  0b00000000,

  0b00000000,	//,
  0b00000000,
  0b00000000,
  0b00000000,
  0b11000000,
  0b01000000,
  0b10000000,
  0b00000000,

  0b00000000,	//-
  0b00000000,
  0b11111000,
  0b00000000,
  0b00000000,
  0b00000000,
  0b00000000,
  0b00000000,

  0b00000000,	//.
  0b00000000,
  0b00000000,
  0b00000000,
  0b00000000,
  0b11000000,
  0b11000000,
  0b00000000,

  0b00000000,	///
  0b00001000,
  0b00010000,
  0b00100000,
  0b01000000,
  0b10000000,
  0b00000000,
  0b00000000,

  0b01110000,	//0
  0b10001000,
  0b10011000,
  0b10101000,
  0b11001000,
  0b10001000,
  0b01110000,
  0b00000000,

  0b01000000,	//1
  0b11000000,
  0b01000000,
  0b01000000,
  0b01000000,
  0b01000000,
  0b11100000,
  0b00000000,

  0b01110000,	//2
  0b10001000,
  0b00001000,
  0b00010000,
  0b00100000,
  0b01000000,
  0b11111000,
  0b00000000,

  0b11111000,	//3
  0b00010000,
  0b00100000,
  0b00010000,
  0b00001000,
  0b10001000,
  0b01110000,
  0b00000000,

  0b00010000,	//4
  0b00110000,
  0b01010000,
  0b10010000,
  0b11111000,
  0b00010000,
  0b00010000,
  0b00000000,

  0b11111000,	//5
  0b10000000,
  0b11110000,
  0b00001000,
  0b00001000,
  0b10001000,
  0b01110000,
  0b00000000,

  0b00110000,	//6
  0b01000000,
  0b10000000,
  0b11110000,
  0b10001000,
  0b10001000,
  0b01110000,
  0b00000000,

  0b11111000,	//7
  0b10001000,
  0b00001000,
  0b00010000,
  0b00100000,
  0b00100000,
  0b00100000,
  0b00000000,

  0b01110000,	//8
  0b10001000,
  0b10001000,
  0b01110000,
  0b10001000,
  0b10001000,
  0b01110000,
  0b00000000,

  0b01110000,	//9
  0b10001000,
  0b10001000,
  0b01111000,
  0b00001000,
  0b00010000,
  0b01100000,
  0b00000000,

  0b00000000,	//:
  0b11000000,
  0b11000000,
  0b00000000,
  0b11000000,
  0b11000000,
  0b00000000,
  0b00000000,

  0b00000000,	//;
  0b11000000,
  0b11000000,
  0b00000000,
  0b11000000,
  0b01000000,
  0b10000000,
  0b00000000,

  0b00010000,	//<
  0b00100000,
  0b01000000,
  0b10000000,
  0b01000000,
  0b00100000,
  0b00010000,
  0b00000000,

  0b00000000,	//=
  0b00000000,
  0b11111000,
  0b00000000,
  0b11111000,
  0b00000000,
  0b00000000,
  0b00000000,

  0b10000000,	//>
  0b01000000,
  0b00100000,
  0b00010000,
  0b00100000,
  0b01000000,
  0b10000000,
  0b00000000,

  0b01110000,	//?
  0b10001000,
  0b00001000,
  0b00010000,
  0b00100000,
  0b00000000,
  0b00100000,
  0b00000000,

  0b01110000,	//@
  0b10001000,
  0b00001000,
  0b01101000,
  0b10101000,
  0b10101000,
  0b01110000,
  0b00000000,

  0b01110000,	//A
  0b10001000,
  0b10001000,
  0b10001000,
  0b11111000,
  0b10001000,
  0b10001000,
  0b00000000,

  0b11110000,	//0b
  0b10001000,
  0b10001000,
  0b11110000,
  0b10001000,
  0b10001000,
  0b11110000,
  0b00000000,

  0b01110000,	//C
  0b10001000,
  0b10000000,
  0b10000000,
  0b10000000,
  0b10001000,
  0b01110000,
  0b00000000,

  0b11100000,	//D
  0b10010000,
  0b10001000,
  0b10001000,
  0b10001000,
  0b10010000,
  0b11100000,
  0b00000000,

  0b11111000,	//E
  0b10000000,
  0b10000000,
  0b11110000,
  0b10000000,
  0b10000000,
  0b11111000,
  0b00000000,

  0b11111000,	//F
  0b10000000,
  0b10000000,
  0b11110000,
  0b10000000,
  0b10000000,
  0b10000000,
  0b00000000,

  0b01110000,	//G
  0b10001000,
  0b10000000,
  0b10111000,
  0b10001000,
  0b10001000,
  0b01111000,
  0b00000000,

  0b10001000,	//H
  0b10001000,
  0b10001000,
  0b11111000,
  0b10001000,
  0b10001000,
  0b10001000,
  0b00000000,

  0b11100000,	//I
  0b01000000,
  0b01000000,
  0b01000000,
  0b01000000,
  0b01000000,
  0b11100000,
  0b00000000,

  0b00111000,	//J
  0b00010000,
  0b00010000,
  0b00010000,
  0b00010000,
  0b10010000,
  0b01100000,
  0b00000000,

  0b10001000,	//K
  0b10010000,
  0b10100000,
  0b11000000,
  0b10100000,
  0b10010000,
  0b10001000,
  0b00000000,

  0b10000000,	//L
  0b10000000,
  0b10000000,
  0b10000000,
  0b10000000,
  0b10000000,
  0b11111000,
  0b00000000,

  0b10001000,	//M
  0b11011000,
  0b10101000,
  0b10101000,
  0b10001000,
  0b10001000,
  0b10001000,
  0b00000000,

  0b10001000,	//N
  0b10001000,
  0b11001000,
  0b10101000,
  0b10011000,
  0b10001000,
  0b10001000,
  0b00000000,

  0b01110000,	//O
  0b10001000,
  0b10001000,
  0b10001000,
  0b10001000,
  0b10001000,
  0b01110000,
  0b00000000,

  0b11110000,	//P
  0b10001000,
  0b10001000,
  0b11110000,
  0b10000000,
  0b10000000,
  0b10000000,
  0b00000000,

  0b01110000,	//Q
  0b10001000,
  0b10001000,
  0b10001000,
  0b10101000,
  0b10010000,
  0b01101000,
  0b00000000,

  0b11110000,	//R
  0b10001000,
  0b10001000,
  0b11110000,
  0b10100000,
  0b10010000,
  0b10001000,
  0b00000000,

  0b01111000,	//S
  0b10000000,
  0b10000000,
  0b01110000,
  0b00001000,
  0b00001000,
  0b11110000,
  0b00000000,

  0b11111000,	//T
  0b00100000,
  0b00100000,
  0b00100000,
  0b00100000,
  0b00100000,
  0b00100000,
  0b00000000,

  0b10001000,	//U
  0b10001000,
  0b10001000,
  0b10001000,
  0b10001000,
  0b10001000,
  0b01110000,
  0b00000000,

  0b10001000,	//V
  0b10001000,
  0b10001000,
  0b10001000,
  0b10001000,
  0b01010000,
  0b00100000,
  0b00000000,

  0b10001000,	//W
  0b10001000,
  0b10001000,
  0b10101000,
  0b10101000,
  0b10101000,
  0b01010000,
  0b00000000,

  0b10001000,	//X
  0b10001000,
  0b01010000,
  0b00100000,
  0b01010000,
  0b10001000,
  0b10001000,
  0b00000000,

  0b10001000,	//Y
  0b10001000,
  0b10001000,
  0b01010000,
  0b00100000,
  0b00100000,
  0b00100000,
  0b00000000,

  0b11111000,	//Z
  0b00001000,
  0b00010000,
  0b00100000,
  0b01000000,
  0b10000000,
  0b11111000,
  0b00000000,

  0b11100000,	//[
  0b10000000,
  0b10000000,
  0b10000000,
  0b10000000,
  0b10000000,
  0b11100000,
  0b00000000,

  0b00000000,	//(0backward Slash)
  0b10000000,
  0b01000000,
  0b00100000,
  0b00010000,
  0b00001000,
  0b00000000,
  0b00000000,

  0b11100000,	//]
  0b00100000,
  0b00100000,
  0b00100000,
  0b00100000,
  0b00100000,
  0b11100000,
  0b00000000,

  0b00100000,	//^
  0b01010000,
  0b10001000,
  0b00000000,
  0b00000000,
  0b00000000,
  0b00000000,
  0b00000000,

  0b00000000,	//_
  0b00000000,
  0b00000000,
  0b00000000,
  0b00000000,
  0b00000000,
  0b11111000,
  0b00000000,

  0b10000000,	//`
  0b01000000,
  0b00100000,
  0b00000000,
  0b00000000,
  0b00000000,
  0b00000000,
  0b00000000,

  0b00000000,	//a
  0b00000000,
  0b01110000,
  0b00001000,
  0b01111000,
  0b10001000,
  0b01111000,
  0b00000000,

  0b10000000,	//0b
  0b10000000,
  0b10110000,
  0b11001000,
  0b10001000,
  0b10001000,
  0b11110000,
  0b00000000,

  0b00000000,	//c
  0b00000000,
  0b01110000,
  0b10001000,
  0b10000000,
  0b10001000,
  0b01110000,
  0b00000000,

  0b00001000,	//d
  0b00001000,
  0b01101000,
  0b10011000,
  0b10001000,
  0b10001000,
  0b01111000,
  0b00000000,

  0b00000000,	//e
  0b00000000,
  0b01110000,
  0b10001000,
  0b11111000,
  0b10000000,
  0b01110000,
  0b00000000,

  0b00110000,	//f
  0b01001000,
  0b01000000,
  0b11100000,
  0b01000000,
  0b01000000,
  0b01000000,
  0b00000000,

  0b00000000,	//g
  0b01111000,
  0b10001000,
  0b10001000,
  0b01111000,
  0b00001000,
  0b01110000,
  0b00000000,

  0b10000000,	//h
  0b10000000,
  0b10110000,
  0b11001000,
  0b10001000,
  0b10001000,
  0b10001000,
  0b00000000,

  0b01000000,	//i
  0b00000000,
  0b11000000,
  0b01000000,
  0b01000000,
  0b01000000,
  0b11100000,
  0b00000000,

  0b00010000,	//j
  0b00000000,
  0b00110000,
  0b00010000,
  0b00010000,
  0b10010000,
  0b01100000,
  0b00000000,

  0b10000000,	//k
  0b10000000,
  0b10010000,
  0b10100000,
  0b11000000,
  0b10100000,
  0b10010000,
  0b00000000,

  0b11000000,	//l
  0b01000000,
  0b01000000,
  0b01000000,
  0b01000000,
  0b01000000,
  0b11100000,
  0b00000000,

  0b00000000,	//m
  0b00000000,
  0b11010000,
  0b10101000,
  0b10101000,
  0b10001000,
  0b10001000,
  0b00000000,

  0b00000000,	//n
  0b00000000,
  0b10110000,
  0b11001000,
  0b10001000,
  0b10001000,
  0b10001000,
  0b00000000,

  0b00000000,	//o
  0b00000000,
  0b01110000,
  0b10001000,
  0b10001000,
  0b10001000,
  0b01110000,
  0b00000000,

  0b00000000,	//p
  0b00000000,
  0b11110000,
  0b10001000,
  0b11110000,
  0b10000000,
  0b10000000,
  0b00000000,

  0b00000000,	//q
  0b00000000,
  0b01101000,
  0b10011000,
  0b01111000,
  0b00001000,
  0b00001000,
  0b00000000,

  0b00000000,	//r
  0b00000000,
  0b10110000,
  0b11001000,
  0b10000000,
  0b10000000,
  0b10000000,
  0b00000000,

  0b00000000,	//s
  0b00000000,
  0b01110000,
  0b10000000,
  0b01110000,
  0b00001000,
  0b11110000,
  0b00000000,

  0b01000000,	//t
  0b01000000,
  0b11100000,
  0b01000000,
  0b01000000,
  0b01001000,
  0b00110000,
  0b00000000,

  0b00000000,	//u
  0b00000000,
  0b10001000,
  0b10001000,
  0b10001000,
  0b10011000,
  0b01101000,
  0b00000000,

  0b00000000,	//v
  0b00000000,
  0b10001000,
  0b10001000,
  0b10001000,
  0b01010000,
  0b00100000,
  0b00000000,

  0b00000000,	//w
  0b00000000,
  0b10001000,
  0b10101000,
  0b10101000,
  0b10101000,
  0b01010000,
  0b00000000,

  0b00000000,	//x
  0b00000000,
  0b10001000,
  0b01010000,
  0b00100000,
  0b01010000,
  0b10001000,
  0b00000000,

  0b00000000,	//y
  0b00000000,
  0b10001000,
  0b10001000,
  0b01111000,
  0b00001000,
  0b01110000,
  0b00000000,

  0b00000000,	//z
  0b00000000,
  0b11111000,
  0b00010000,
  0b00100000,
  0b01000000,
  0b11111000,
  0b00000000,

  0b00100000,	//{
  0b01000000,
  0b01000000,
  0b10000000,
  0b01000000,
  0b01000000,
  0b00100000,
  0b00000000,

  0b10000000,	//|
  0b10000000,
  0b10000000,
  0b10000000,
  0b10000000,
  0b10000000,
  0b10000000,
  0b00000000,

  0b10000000,	//}
  0b01000000,
  0b01000000,
  0b00100000,
  0b01000000,
  0b01000000,
  0b10000000,
  0b00000000,

  0b00000000,	//~
  0b00000000,
  0b00000000,
  0b01101000,
  0b10010000,
  0b00000000,
  0b00000000,
  0b00000000,

  0b01100000,	// (Char 0x7F)
  0b10010000,
  0b10010000,
  0b01100000,
  0b00000000,
  0b00000000,
  0b00000000,
  0b00000000
};







#endif /* LCD_MATRIX_H */